From 4bedde1899d6067e41917fd85b60a9d99ac10ec5 Mon Sep 17 00:00:00 2001
From: JF Ding <jian-feng.ding@intel.com>
Date: Fri, 20 Aug 2010 19:00:57 +0800
Subject: [PATCH] vc: to support meego changelog style if detected

need "vc" command shipped with meego-packaging-tools
---
 osc/commandline.py |   46 +++++++++++++++++++++++++++++++++-------------
 1 files changed, 33 insertions(+), 13 deletions(-)

diff --git a/osc/commandline.py b/osc/commandline.py
index d50b45f..7ef4704 100644
--- a/osc/commandline.py
+++ b/osc/commandline.py
@@ -5617,13 +5617,32 @@ Please submit there instead, or use --nodevelproject to force direct submission.
         """
 
         from subprocess import Popen, PIPE
+        import glob, re
+        try:
+            fn_changelog = glob.glob('*.changes')[0]
+            fp = file(fn_changelog)
+            titleline = fp.readline()
+            fp.close()
+            if re.match('^\*\W+(.+\W+\d{1,2}\W+20\d{2})\W+(.+)\W+<(.+)>\W+(.+)$', titleline):
+                meego_style = True
+            else:
+                meego_style = False
+        except IndexError:
+            meego_style = False
+            pass
 
-        if not os.path.exists('/usr/lib/build/vc'):
-            print >>sys.stderr, 'Error: you need build.rpm with version 2009.04.17 or newer'
-            print >>sys.stderr, 'See http://download.opensuse.org/repositories/openSUSE:/Tools/'
-            return 1
+        if meego_style:
+            if not os.path.exists('/usr/bin/vc'):
+                print >>sys.stderr, 'Error: you need meego-packaging-tools for /usr/bin/vc command'
+                return 1
+            cmd_list = ["/usr/bin/vc", ]
+        else:
+            if not os.path.exists('/usr/lib/build/vc'):
+                print >>sys.stderr, 'Error: you need build.rpm with version 2009.04.17 or newer'
+                print >>sys.stderr, 'See http://download.opensuse.org/repositories/openSUSE:/Tools/'
+                return 1
 
-        cmd_list = ["/usr/lib/build/vc", ]
+            cmd_list = ["/usr/lib/build/vc", ]
 
         if len(args) > 0:
             arg = args[0]
@@ -5640,21 +5659,22 @@ Please submit there instead, or use --nodevelproject to force direct submission.
 
             user = conf.get_apiurl_usr(apiurl)
 
-            # work with all combinations of URL with or withouth the ending slash
+            try:
+                os.environ['mailaddr'], os.environ['username'] = get_user_data(apiurl, user, 'email', 'realname')
+            except Exception, e:
+                sys.exit('%s\nget_user_data(email) failed. Try env mailaddr=....\n' % e)
+
+            # mailaddr can be overrided by config one
             if conf.config['api_host_options'][apiurl].has_key('email'):
                 os.environ['mailaddr'] = conf.config['api_host_options'][apiurl]['email']
-            else:
-                try:
-                    os.environ['mailaddr'] = get_user_data(apiurl, user, 'email')[0]
-                except Exception, e:
-                    sys.exit('%s\nget_user_data(email) failed. Try env mailaddr=....\n' % e)
 
         if opts.message:
             cmd_list.append("-m")
             cmd_list.append(opts.message)
 
-        if opts.just_edit:
-            cmd_list.append("-e")
+        if not meego_style:
+            if opts.just_edit:
+                cmd_list.append("-e")
 
         if args:
             cmd_list.extend(args)
-- 
1.7.0.4

